#!/usr/bin/perl

use strict;
use warnings "all";

if (!defined($ARGV[1])) {
	print STDERR "proteinortho5_clean_edges.pl PROTEINORTHO_OUTFILE EDGELIST(S) >CLUSTERED_EDGELIST \nReads Proteinortho outfile and its initial edge list and calculates\nthe remaining edge list after the step of clustering.\n";
	exit;
}


# Proteinortho Output
print STDERR "Cleaning edge list...\n";
my @result;
open(IN,"<$ARGV[0]") || die("Could not open file $ARGV[0]: $!");
while (<IN>) {
	if ($_ =~ /^#/) {next;}
	chomp;
	my @data = split;
	shift(@data); 	shift(@data);	shift(@data);
	my @res;
	foreach (@data) {if ($_ ne "*") {
		my @genes = split(',',$_);
		foreach my $gene (@genes) {
			push(@res,$gene);}
		}
	}
	push(@result,\@res);
}
close(IN);

# Edgelist
my $print = 0;
my $all = 0;
shift(@ARGV);
foreach my $file (@ARGV) {
	open(IN,"<$file") || die("Could not open file $file: $!");
	while (<IN>) {
		chomp;
		if ($_ =~ /^#/) {print $_."\n"; next;}
		my @data = split;
		if (!defined($data[1])) {next;}
		$all++;
		foreach (@result) {			# array of arrays
			my $match = 0;
			foreach (@{$_}) {
				if ($_ eq $data[0] || $_ eq $data[1]) {$match++;}
			}
			if ($match == 1) {last;}					# Only one found in a pair
			elsif ($match == 2) {$print++; print join("\t",@data)."\n"; last;}	# Both found in a pair
			elsif ($match > 2) {die("Error: More than two hits, this should not happen!\n");}
		}
	}
	close(IN);
}

print STDERR "Removed ".($all-$print)." / $all edges\n";
